<template>
  <form @submit.prevent="submitForm" method="post">
    <el-dialog
      title="เพิ่มยุทธศาสตร์"
      v-model="openDialog"
      width="350px"
      :before-close="handleClose"
    >
      <div class="grid grid-cols-4">
        <div class="col-span-full">
          <p>ปีงบประมาณ</p>
          <input
            :class="`${errors.years ? ' border-red-600' : ''}
            w-full
                  px-3
                  py-2
                  rounded
                  rounded-r-none
                  border border-gray-200
                  placeholder-gray-300
                  `"
            v-model="form.budget_year_id"
            type="hidden"
          />
          <input
            :class="`${errors.years ? ' border-red-600' : ''}
            w-full
                  px-3
                  py-2
                  rounded
                  rounded-r-none
                  border border-gray-200
                  placeholder-gray-300
                  `"
            :value="years.year"
            disabled
          />
        </div>
        <div class="col-span-1">
          <p>ยุทธศาสตร์</p>
          <input
            :class="`${errors.number ? ' border-red-600' : ''}
            w-full
                  px-3
                  py-2
                  rounded
                  rounded-r-none
                  border border-gray-200
                  placeholder-gray-300`"
            v-model="form.number"
            placeholder="ลำดับ"
          />
        </div>
        <div class="grid col-span-3">
          <p class="text-transparent">ยุทธศาสตร์</p>
          <input
            :class="`${errors.name ? ' border-red-600' : ''}
            w-full
                  px-3
                  py-2
                  rounded-l-none
                  rounded
                  border border-gray-200
                  placeholder-gray-300`"
            v-model="form.name"
            placeholder="ยุทธศาสตร์"
          />
        </div>
        <small class="text-red-500 font-bold">{{ errors?.number }} </small
        ><br />
        <small class="text-red-500 font-bold">{{ errors?.name }} </small>
      </div>
      <template #footer>
        <span class="dialog-footer">
          <button
            @click="handleClose"
            class="
              transition
              duration-200
              ease-in-out
              transform
              hover:-translate-y-1
              px-3
              py-1
              bg-gradient-to-r
              from-red-600
              to-red-400
              rounded-md
              text-white
              shadow-md
              mr-2
              focus:outline-none
            "
            type="button"
          >
            ยกเลิก
          </button>
          <button
            type="submit"
            class="
              transition
              duration-200
              ease-in-out
              transform
              hover:-translate-y-1
              px-3
              py-1
              bg-gradient-to-r
              from-blue-600
              to-green-400
              rounded-md
              text-white
              shadow-md
              focus:outline-none
            "
          >
            เพิ่ม
          </button>
        </span>
      </template>
    </el-dialog>
  </form>
</template>

<script>
import { Inertia } from "@inertiajs/inertia";
import { defineComponent, onMounted, reactive, ref, toRefs, watch } from "vue";

export default defineComponent({
  props: {
    open: {
      type: Boolean,
      required: true,
    },
    years: Object,
  },
  setup(props, { emit }) {
    //   model
    const { open, years } = toRefs(props);
    const openDialog = ref(false);
    watch(open, (value, prevValue) => {
      openDialog.value = value;
      console.log(value);
    });
    // form
    const form = reactive({
      number: null,
      name: null,
      budget_year_id: years.value.id,
    });
    const errors = reactive({
      number: null,
      name: null,
    });
    const submitForm = () => {
      Inertia.post(route("admin.stargics.store"), form, {
        onError: (err) => {
          errors.number = err.number;
          errors.name = err.name;
        },
        onSuccess: () => handleClose(),
      });
    };

    const handleClose = () => {
      emit("close");
      openDialog.value = false;
      form.number = null;
      form.name = null;
      errors.number = null;
      errors.name = null;
    };
    return {
      years,
      openDialog,
      handleClose,
      submitForm,
      form,
      errors,
    };
  },
});
</script>
